// SQUEEN.cpp: implementation of the SQUEEN class.
//
//////////////////////////////////////////////////////////////////////

#include "SQUEEN.h"

using namespace std;
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

SQUEEN::SQUEEN()
{

}

SQUEEN::~SQUEEN()
{

}


void SQUEEN::start()
{
	board_size = get_board_size ();

	int i, j;
	
	board = new short*[board_size];
	for(i = 0;i < board_size; i++)
		board[i] = new short[board_size];
	for(j = 0;j< board_size;j++)
		for(i = 0;i< board_size;i++)
			board[j][i] = 0;

	fill_board ();
	draw_board ();
	
	for(i = 0;i < board_size; i++)
		delete[] board[i];
	delete board;
}

short SQUEEN::get_board_size (void)
{
	short board_size=0;
		
	cout << "Input board size ( 4 to 8 ) : ";
	cin >> board_size;
	
	while (board_size < 4 || board_size > 8)
	{
		cout << "\n Input ERROR !! ";
		cout << "\n Please re-enter board size ( 4 to 8 ) : ";
		cin >> board_size;
	}
	return board_size;
}

void SQUEEN::draw_board ()
{
	short temp_x, temp_y;

	for (temp_x = 0; temp_x < board_size; temp_x++)  // board top line
		cout << "----";
	cout << "-\n";

	for (temp_y=0; temp_y < board_size; temp_y++)
	{
		for (temp_x=0; temp_x < board_size; temp_x++)
		{
			if (board[temp_y][temp_x] == 0)
				cout << "|   ";
			else
				cout << "| Q ";
		}
		cout << "|\n";   //  new line
		for (temp_x = 0; temp_x < board_size; temp_x++)  // board bottom line
			cout << "----";
		cout << "-\n";
	}
}

void SQUEEN::fill_board ()
{
	short posx=0, posy=0;
	POSITION position;
	
	while (posy < board_size)
	{
		while (posx < board_size && posy < board_size)
		{
			if (guarded (posx, posy)) // return 1 => queen guarded, 0 => not guarded
			{
				position.posx = posx;
				position.posy = posy;
				board [posy][posx] = 1;
				stack.push (position);
				posy++;
				posx=0;
			}
			else posx++;

			while (posx >= board_size)
			{
				stack.pop (position);
				posx = position.posx;
				posy = position.posy;
				board [posy][posx] = 0;
				posx++;
			}
		}
	}
}

bool SQUEEN::guarded (short posx, short posy)
{
	short x,y;

	for (x=posx-1; x >= 0; x--)				// üũ
		if (board[posy][x] ==1)
			return FAIL;
	
	for (y=posy-1; y >= 0; y--)				// üũ
		if (board[y][posx] == 1)
			return FAIL;

	for (x=posx-1,y=posy-1; x >=0 && y >=0; x--,y--)				//  밢
		if (board[y][x] == 1)
			return FAIL;

	for (x=posx+1,y=posy-1; x < board_size && y >= 0; x++, y--)		//  밢
		if (board[y][x] == 1)
			return FAIL;
	
	return TRUE;
}
