// STACK.cpp: implementation of the STACK class.
//
//////////////////////////////////////////////////////////////////////

#include "STACK.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


template <class DATA>
STACK<DATA>::STACK ()
{
	its_count = 0;
	its_p_top = NULL; 
}

template <class DATA>
STACK<DATA>::~STACK ()
{
	NODE<DATA>* temp;
	while (its_p_top != NULL)
	{
		temp = its_p_top;     
		its_p_top = its_p_top->next_node;  
		delete temp;
	} 
}

template <class DATA>
bool STACK<DATA>::push (DATA& data_in)
{
	NODE<DATA>* new_node = new NODE<DATA>;
	bool result;

	if (new_node==NULL)           //  ޸ Ҵ ҽ..
		result = FAIL;
	else 
	{
		new_node->data = data_in;			// ԷµŸ new_node 
		new_node->next_node = its_p_top;	// new_node 带  top  

		its_p_top = new_node;				// ο top  new_node Ҵ
		its_count++;
		
		result = TRUE;
	}
	return result;
}

template <class DATA>
bool STACK<DATA>::pop (DATA& data_out)
{
	NODE<DATA>* del_node;
	bool result;

	if (is_empty ())  // empty => return 1,  not empty => return 0
		result = FAIL;
	else
	{
		data_out = its_p_top->data;

		del_node = its_p_top;				// ޸   ּ 
		its_p_top = its_p_top->next_node;	// top  top  
		its_count--;
		
		delete del_node;					// ޸ 
		result = TRUE;
	}
	return result;
}

template <class DATA>
bool STACK<DATA>::top (DATA& data_out)
{
	bool result;

	if (is_empty ())   // empty => return 1,  not empty => return 0
		result = FAIL;
	else
	{
		data_out = its_p_top->data;
		
		result = TRUE;
	}
	return result;
}

template <class DATA>
bool STACK<DATA>::is_empty ()   // empty => return 1,  not empty => return 0
{
	return (its_count==0);


}
